DROP TABLE IF EXISTS TB_USUARIO CASCADE;
CREATE TABLE TB_USUARIO(
    COD_USUARIO bigint GENERATED BY DEFAULT AS IDENTITY primary key,
    NOME VARCHAR(255),
    CPF VARCHAR(255),
    EMAIL VARCHAR(255),
    SENHA VARCHAR(255),
    LOGIN VARCHAR(255),
    PERFIL VARCHAR(255)
);
DROP TABLE IF EXISTS TB_MUSICA;
CREATE TABLE TB_MUSICA(
    COD_MUSICA bigint GENERATED BY DEFAULT AS IDENTITY primary key,
    NOME VARCHAR(255),
    URL_CIFRA VARCHAR(255),
    URL_VIDEO VARCHAR(255),
    URL_AUDIO VARCHAR(255),
    LETRA TEXT,
    CATEGORIA VARCHAR(255),
    ARTISTA VARCHAR(255),
    OBSERVACOES TEXT,
    COD_USUARIO bigint not null,
    foreign key (COD_USUARIO) references TB_USUARIO (COD_USUARIO)
);

DROP TABLE IF EXISTS TB_REPERTORIO;
CREATE TABLE TB_REPERTORIO(
    COD_REPERTORIO bigint GENERATED BY DEFAULT AS IDENTITY primary key,
    NOME VARCHAR(255),
    DATA_CRIACAO TIMESTAMP,
    DATA_EXECUCAO TIMESTAMP,
    COD_USUARIO bigint,
    OBSERVACOES TEXT,
    foreign key (COD_USUARIO) references TB_USUARIO (COD_USUARIO)
);

drop table if exists TB_REPERTORIO_MUSICAS;
create table TB_REPERTORIO_MUSICAS(
    COD_REPERTORIO bigint,
    COD_MUSICA bigint,
    foreign key (COD_REPERTORIO) references TB_REPERTORIO(COD_REPERTORIO),
    foreign key (COD_MUSICA) references TB_MUSICA(COD_MUSICA)
);

DROP TABLE IF EXISTS TB_LOG ;
CREATE TABLE TB_LOG(
    COD_LOG bigint GENERATED BY DEFAULT AS IDENTITY primary key,
    DESCRICAO VARCHAR(255),
    TIPO VARCHAR(255),
    AUTOR VARCHAR(255),
    ID_OBJETO BIGINT
);
